/*********************************************************************/
/*                                                                   */
/*  This Program Written By Paul Edwards.                            */
/*  Released to the public domain.                                   */
/*                                                                   */
/*********************************************************************/
/*********************************************************************/
/*                                                                   */
/*  This program converts an ASCII file into the local character     */
/*  set.                                                             */
/*                                                                   */
/*********************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "fasc.h"

int main(int argc, char **argv)
{
    FILE *fp;
    FILE *fq;
    int c;
    long count = 0;
    
    if (argc <= 2)
    {
        printf("usage: asc2loc infile outfile\n");
        return (EXIT_FAILURE);
    }
    
    fp = fopen(*(argv + 1), "rb");
    if (fp == NULL)
    {
        printf("failed to open %s for reading\n", *(argv + 1));
        return (EXIT_FAILURE);
    }

    fq = fopen(*(argv + 2), "w");
    if (fq == NULL)
    {
        printf("failed to open %s for writing\n", *(argv + 2));
        return (EXIT_FAILURE);
    }
    
    while ((c = fgetc(fp)) != EOF)
    {
        int origc;
        
        origc = c;

        c = fasc(c);
        if (c == '\0')
        {
            printf("converting unknown character x'%02X' at offset %ld"
                   " to space\n",
                   origc, count);
            c = ' ';
        }

        if (c != '\r') /* silently ignore carriage returns */
        {
            fputc(c, fq);
        }
        count++;
    }
    return (0);
}
