/*********************************************************************/
/*                                                                   */
/*  This Program Written By Paul Edwards.                            */
/*  Released to the public domain.                                   */
/*                                                                   */
/*********************************************************************/
/*********************************************************************/
/*                                                                   */
/*  labaws - change name of AWS tape to be AWSTAP                    */
/*                                                                   */
/*  warning - will update existing file in-place                     */
/*                                                                   */
/*********************************************************************/

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
    FILE *f;
    
    if (argc < 2)
    {
        printf("usage: labaws <filename>\n");
        printf("used to update tape label to be AWSTAP\n");
        printf("warning - will update existing file without checks\n");
        return (EXIT_FAILURE);
    }
    
    f = fopen(*(argv + 1), "r+b");
    if (f == NULL)
    {
        printf("failed to open file %s\n", *(argv + 1));
        return (EXIT_FAILURE);
    }
    fseek(f, 10, SEEK_SET);
    fprintf(f, "\xC1\xE6\xE2\xE3\xC1\xD7");
    fclose(f);
    return (0);
}
