/*********************************************************************/
/*                                                                   */
/*  This Program Written By Paul Edwards.                            */
/*  Released to the public domain.                                   */
/*                                                                   */
/*********************************************************************/
/*********************************************************************/
/*                                                                   */
/*  mkpdsn - make a PDS name                                         */
/*                                                                   */
/*  The first parameter is the output filename                       */
/*                                                                   */
/*  The second parameter is a PDS name, which may have single quotes */
/*                                                                   */
/*  The third parameter is a member name.                            */
/*                                                                   */
/*  example of use:                                                  */
/*                                                                   */
/*  mkpdsn(outf, inpds, inmem);                                      */
/*  where inpds could be "dd:in" or "'sys1.parmlib'"                 */
/*                                                                   */
/*  Caller is responsible for sizing buffers                         */
/*                                                                   */
/*********************************************************************/

#include <string.h>

void mkpdsn(char *outf, char *inpds, char *inmem)
{
    char *p;

    strcpy(outf, inpds);
    if (*outf == '\'')
    {
        p = strchr(outf + 1, '\'');
        if (p != NULL)
        {
            *p = '\0';
        }
    }
    else
    {
        p = outf + strlen(outf);
    }
    strcat(p, "(");
    strcat(p, inmem);
    strcat(p, ")");
    if (outf[0] == '\'')
    {
        strcat(p, "'");
    }
    return;
}
