/*********************************************************************/
/*                                                                   */
/*  This Program Written By Paul Edwards.                            */
/*  Released to the public domain                                    */
/*                                                                   */
/*********************************************************************/
/*********************************************************************/
/*                                                                   */
/*  repchar - replace one character with another in a file           */
/*                                                                   */
/*********************************************************************/

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
    int c;
    FILE *fp;
    FILE *fq;
    int inch;
    int outch;
    
    if (argc <= 4)
    {
        printf("usage: repchar infile outfile inch outch\n");
        printf("e.g. repchar in.txt out.txt 0x93 0x22\n");
        return (EXIT_FAILURE);
    }

    fp = fopen(*(argv + 1), "rb");
    if (fp == NULL)
    {
        printf("failed to open %s for input\n", *(argv + 1));
        return (EXIT_FAILURE);
    }
    
    fq = fopen(*(argv + 2), "wb");
    if (fq == NULL)
    {
        printf("failed to open %s for input\n", *(argv + 2));
        return (EXIT_FAILURE);
    }

    inch = strtol(*(argv + 3), NULL, 0);
    outch = strtol(*(argv + 4), NULL, 0);
    while ((c = fgetc(fp)) != EOF)
    {
        if (c == inch)
        {
            c = outch;
        }
        fputc(c,fq);
    }

    if (ferror(fp) || ferror(fq))
    {
        printf("i/o error\n");
        return (EXIT_FAILURE);
    }

    return (0);
}
